<?php

Yii::import('application.modules.core_models.models._base.BaseModel');

/**
 * This is the model base class for the table "twilio_log".
 * DO NOT MODIFY THIS FILE! It is automatically generated by giix.
 * If any changes are necessary, you must set or override the required
 * property or method in class "TwilioLog".
 *
 * Columns in table "twilio_log" available as properties of the model,
 * followed by relations of table "twilio_log" available as properties of the model.
 *
 * @property string $id
 * @property string $twilio_number_id
 * @property string $provider_id
 * @property string $practice_id
 * @property integer $twilio_partner_id
 * @property string $caller_option
 * @property integer $is_qualified
 * @property string $caller
 * @property string $target_number
 * @property string $tw_call_sid
 * @property string $tw_account_sid
 * @property string $tw_from
 * @property string $tw_to
 * @property string $tw_call_status
 * @property string $tw_api_version
 * @property string $tw_direction
 * @property string $tw_forwarded_from
 * @property string $tw_from_city
 * @property string $tw_from_state
 * @property string $tw_from_zip
 * @property string $tw_from_country
 * @property string $tw_to_city
 * @property string $tw_to_state
 * @property string $tw_to_zip
 * @property string $tw_to_country
 * @property string $tw_call_duration
 * @property string $tw_recording_url
 * @property string $tw_recording_sid
 * @property string $tw_recording_duration
 * @property integer $transcribed_flag
 * @property string $transcription
 * @property string $time_started
 * @property string $time_ended
 * @property string $time_connected
 * @property int $audio_status
 * @property dateTime $audio_verified_in
 *
 * @property TwilioNumber $twilioNumber
 *
 */
abstract class BaseTwilioLog extends BaseModel
{

    public $twilio_partner;

    public static function model($className = __CLASS__)
    {
        return parent::model($className);
    }

    public function getSecCallDuration()
    {

        $duration = TwilioLog::model()->findByPk($this->id);
        return TimeComponent::getMinutes($duration->tw_call_duration);
    }

    /*
     * Finds whether a customer called during the prior 30 days.
     */

    public static function priorDaysCall($id)
    {

        $log = TwilioLog::model()->find('id=:id', array(':id' => $id));
        if ($log) {
            $sqlF = sprintf(
                "select IFNULL(SUM(1),0) AS total from twilio_log
                where tw_from = '%s'
                and tw_to = '%s'
                and time_started between  DATE_SUB(date('%s'), INTERVAL 30 DAY) and date('%s')
                and id <> %s",
                $log->tw_from,
                $log->tw_to,
                $log->time_started,
                $log->time_started,
                $log->id
            );
            $prior30DaysCall = Yii::app()->db->createCommand($sqlF)->queryAll();
        }
        return ($prior30DaysCall[0]['total'] > 0 ? true : false);
    }

    public function tableName()
    {
        return 'twilio_log';
    }

    public static function representingColumn()
    {
        return 'id';
    }

    public function rules()
    {
        return array(
            array('twilio_number_id', 'required'),
            array('twilio_number_id, provider_id', 'length', 'max' => 11),
            array('practice_id', 'length', 'max' => 30),
            array('caller_option', 'length', 'max' => 1),
            array('tw_call_sid, tw_account_sid, tw_recording_sid', 'length', 'max' => 34),
            array('tw_from, tw_to', 'length', 'max' => 12),
            array('tw_forwarded_from', 'length', 'max' => 20),
            array('caller, tw_call_status, tw_api_version, tw_direction', 'length', 'max' => 15),
            array('tw_from_city, tw_from_state, tw_from_country, tw_to_city, tw_to_state, tw_to_country',
                'length', 'max' => 25),
            array('tw_from_zip, tw_to_zip', 'length', 'max' => 10),
            array('tw_call_duration, tw_recording_duration', 'length', 'max' => 5),
            array('tw_recording_url', 'length', 'max' => 255),
            array('time_started, time_ended, time_connected', 'safe'),
            array('is_qualified', 'numerical', 'integerOnly' => true),
            array('twilio_partner, audio_verified_in, audio_status', 'safe', 'on' => 'search'),
            array('provider_id, practice_id, target_number, twilio_partner_id, caller_option, tw_call_sid, '
                . 'tw_account_sid, tw_from, tw_to, tw_call_status, tw_api_version, tw_direction, tw_forwarded_from, '
                . 'tw_from_city, tw_from_state, tw_from_zip, tw_from_country, tw_to_city, tw_to_state, tw_to_zip, '
                . 'tw_to_country, tw_call_duration, tw_recording_url, tw_recording_sid, tw_recording_duration, '
                . 'transcribed_flag, transcription, time_started, time_ended, time_connected', 'default',
                'setOnEmpty' => true, 'value' => null),
            array('id, twilio_number_id, provider_id, practice_id, twilio_partner_id, caller_option, '
                . 'is_qualified, caller, target_number, tw_call_sid, tw_account_sid, tw_from, tw_to, '
                . 'tw_call_status, tw_api_version, tw_direction, tw_forwarded_from, tw_from_city, '
                . 'tw_from_state, tw_from_zip, tw_from_country, tw_to_city, tw_to_state, tw_to_zip, '
                . 'tw_to_country, tw_call_duration, tw_recording_url, tw_recording_sid, tw_recording_duration, '
                . 'transcribed_flag, transcription, time_started, time_ended, time_connected', 'safe',
                'on' => 'search'),
        );
    }

    public function relations()
    {
        return array(
            'practice' => array(self::BELONGS_TO, 'Practice', 'practice_id'),
            'provider' => array(self::BELONGS_TO, 'Provider', 'provider_id'),
            'twilioNumber' => array(self::BELONGS_TO, 'TwilioNumber', 'twilio_number_id'),
            'tableTwilioPartner' => array(self::BELONGS_TO, 'TwilioPartner', 'twilio_partner_id'),
        );
    }

    public function pivotModels()
    {
        return array(
        );
    }

    public function attributeLabels()
    {
        return array(
            'id' => Yii::t('app', 'ID'),
            'twilio_number_id' => Yii::t('app', 'Twilio Number ID'),
            'twilio_partner' => Yii::t('app', 'Twilio Partner'),
            'provider_id' => Yii::t('app', 'Provider'),
            'practice_id' => Yii::t('app', 'Practice'),
            'twilio_partner_id' => Yii::t('app', 'Twilio Partner'),
            'target_number' => Yii::t('app', 'Target Number'),
            'caller_option' => Yii::t('app', 'Caller Type'),
            'is_qualified' => Yii::t('app', 'Is Qualified New Patient'),
            'caller' => Yii::t('app', 'Caller ID'),
            'tw_call_sid' => Yii::t('app', 'Call SID'),
            'tw_account_sid' => Yii::t('app', 'Account SID'),
            'tw_from' => Yii::t('app', 'From #'),
            'tw_to' => Yii::t('app', 'To #'),
            'tw_call_status' => Yii::t('app', 'Call Status'),
            'tw_api_version' => Yii::t('app', 'API Version'),
            'tw_direction' => Yii::t('app', 'Direction'),
            'tw_forwarded_from' => Yii::t('app', 'Forwarded From'),
            'tw_from_city' => Yii::t('app', 'From City'),
            'tw_from_state' => Yii::t('app', 'From State'),
            'tw_from_zip' => Yii::t('app', 'From Zip'),
            'tw_from_country' => Yii::t('app', 'From Country'),
            'tw_to_city' => Yii::t('app', 'To City'),
            'tw_to_state' => Yii::t('app', 'To State'),
            'tw_to_zip' => Yii::t('app', 'To Zip'),
            'tw_to_country' => Yii::t('app', 'To Country'),
            'tw_call_duration' => Yii::t('app', 'Call Duration (s)'),
            'tw_recording_url' => Yii::t('app', 'Recording URL'),
            'tw_recording_sid' => Yii::t('app', 'Recorded'),
            'audio_verified_in' => Yii::t('app', 'Audio Verified In'),
            'audio_status' => Yii::t('app', 'Audio Status'),
            'tw_recording_duration' => Yii::t('app', 'Recording Duration (s)'),
            'transcribed_flag' => Yii::t('app', 'Transcribed Flag'),
            'transcription' => Yii::t('app', 'Transcription'),
            'time_started' => Yii::t('app', 'Time Started'),
            'time_ended' => Yii::t('app', 'Time Ended'),
            'time_connected' => Yii::t('app', 'Time Connected'),
        );
    }

    /**
     * Retrieves a list of models based on the current search/filter conditions.
     *
     * Typical usecase:
     * - Initialize the model fields with values from filter form.
     * - Execute this method to get CActiveDataProvider instance which will filter
     * models according to data in model fields.
     * - Pass data provider to CGridView, CListView or any similar widget.
     *
     * @return CActiveDataProvider the data provider that can return the models
     * based on the search/filter conditions.
     */
    public function search()
    {

        // @todo Please modify the following code to remove attributes that should not be searched.

        $criteria = new CDbCriteria;

        $criteria->compare('twilio_number_id', $this->twilio_number_id);
        $criteria->compare('provider_id', $this->provider_id);
        $criteria->compare('practice_id', $this->practice_id);
        $criteria->compare('twilio_partner_id', $this->twilio_partner_id);
        $criteria->compare('caller_option', $this->caller_option);
        $criteria->compare('is_qualified', $this->is_qualified);
        $criteria->compare('caller', $this->caller);
        $criteria->compare('target_number', $this->target_number);
        $criteria->compare('tw_call_sid', $this->tw_call_sid);
        $criteria->compare('tw_account_sid', $this->tw_account_sid);
        $criteria->compare('tw_from', $this->tw_from);
        $criteria->compare('tw_to', $this->tw_to);
        $criteria->compare('tw_call_status', $this->tw_call_status);
        $criteria->compare('tw_api_version', $this->tw_api_version);
        $criteria->compare('tw_direction', $this->tw_direction);
        $criteria->compare('tw_forwarded_from', $this->tw_forwarded_from);
        $criteria->compare('tw_from_city', $this->tw_from_city);
        $criteria->compare('tw_from_state', $this->tw_from_state);
        $criteria->compare('tw_from_zip', $this->tw_from_zip);
        $criteria->compare('tw_from_country', $this->tw_from_country);
        $criteria->compare('tw_to_city', $this->tw_to_city);
        $criteria->compare('tw_to_state', $this->tw_to_state);
        $criteria->compare('tw_to_zip', $this->tw_to_zip);
        $criteria->compare('tw_to_country', $this->tw_to_country);
        $criteria->compare('tw_call_duration', $this->tw_call_duration);
        $criteria->compare('tw_recording_url', $this->tw_recording_url);
        $criteria->compare('tw_recording_sid', $this->tw_recording_sid);
        $criteria->compare('tw_recording_duration', $this->tw_recording_duration);
        $criteria->compare('audio_verified_in', $this->audio_verified_in);
        $criteria->compare('audio_status', $this->audio_status);
        $criteria->compare('transcribed_flag', $this->transcribed_flag);
        $criteria->compare('time_started', $this->time_started);
        $criteria->compare('time_ended', $this->time_ended);
        $criteria->compare('time_connected', $this->time_connected);

        return new CActiveDataProvider($this, array(
            'criteria' => $criteria,
            'pagination' => array('pageSize' => 100)
        ));
    }

    public static function label($n = 1)
    {
        return Yii::t('app', 'TwilioLog|TwilioLogs', $n);
    }

}
